<?php
/*
* 2007-2015 PrestaShop
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author PrestaShop SA <contact@prestashop.com>
*  @copyright  2007-2015 PrestaShop SA
*  @license    http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*/

/**
 * @since 1.5.0
 */
include dirname(__FILE__) . '../../../../config/config.inc.php';
include dirname(__FILE__) . '../../../../init.php';

class ipasspay_directValidationModuleFrontController extends ModuleFrontController
{
    /**
     * @see FrontController::postProcess()
     */
    public function __construct()
    {
        parent::__construct();

    }


    public function postProcess()
    {
        //异步通知
        if (isset($_REQUEST['asyn_notify'])) {
            $this->asyNofity();
            exit;
        }

        $data = array(
            'order_no' => $this->context->cart->id,
            //'client_ip' => $this->getIP(),
        );
        $context = Context::getContext();
        $ipasspay_direct = Module::getInstanceByName('ipasspay_direct');
        $cart = $this->context->cart;
        if ($cart->id_customer == 0 || $cart->id_address_delivery == 0 || $cart->id_address_invoice == 0 || !$this->module->active) {
            Tools::redirect('index.php?controller=order&step=1');
        }
        // Check that this payment option is still available in case the customer changed his address just before the end of the checkout process
        $authorized = false;
        foreach (Module::getPaymentModules() as $module) {
            if ($module['name'] == 'ipasspay_direct') {
                $authorized = true;
                break;
            }
        }
        if (!$authorized) {
            die($this->module->l('This payment method is not available.', 'validation'));
        }
        $this->context->smarty->assign([
            'params' => $_REQUEST,
        ]);
        $customer = new Customer((int) $cart->id_customer);
        if (!Validate::isLoadedObject($customer)) {
            Tools::redirect('index.php?controller=order&step=1');
        }
        //验证信用卡信息
        $_REQUEST['card-expiry-year']= substr($_REQUEST['card-expiry-year'],-2);//取后两位
        $result1 = $this->validate($_REQUEST['card-number'], $_REQUEST['card-expiry-month'], $_REQUEST['card-expiry-year']);
        echo $result1;
        if ($result1 != 1) {
            echo '<script>alert("Please check your credit card info.");history.back(); </script>';
            exit;
            //Tools::redirect('index.php?controller=order&step=3&ipasspay_directerror=Please check your credit card info.');
        }
        $currency = $context->currency;
        $total = (float) ($cart->getOrderTotal(true, Cart::BOTH));
        $address = new Address(intval($cart->id_address_invoice));
        // 得到国家，地区，城市
        if ($address->id_state) {
            $state = new State(intval($address->id_state));
        }

        if ($address->id_country) {
            $country = new Country(intval($address->id_country));
        }

        $this->module->validateOrder((int)$this->context->cart->id, Configuration::get('PS_OS_PREPARATION'), $total, $this->module->displayName, null, array(), null, false, $customer->secure_key);

        $mid = Configuration::get('IPASSPAY_DIRECT_MERCHANT_ID');
        $app_id = Configuration::get('IPASSPAY_APP_ID');
        $api_secret = Configuration::get('IPASSPAY_API_SECRET');
        $gateway_version = Configuration::get('IPASSPAY_DIRECT_GATEWAY_VERSION');
        $gateway_url = Configuration::get('IPASSPAY_DIRECT_GATEWAY_URL');
        $asyn_url = Configuration::get('IPASSPAY_DIRECT_ASYN_URL');
        //$syn_url = Configuration::get('IPASSPAY_SYN_URL');

        $curlPost['merchant_id'] = $mid;
        $curlPost['app_id'] = $app_id;
        $curlPost['order_no'] = time() . rand(111111,999999)."prestashop".$data['order_no'];
        $curlPost['order_currency'] = $currency->iso_code;
        //$curlPost['order_currency'] = 'USD';
        $curlPost['order_amount'] = number_format((float) $cart->getOrderTotal(true, 3), 2, '.', '');
        $curlPost['order_items'] = 'goods';
        $curlPost['card_no'] = trim($_REQUEST['card-number']);
        $curlPost['card_ex_year'] = $_REQUEST['card-expiry-year'];
        $curlPost['card_ex_month'] = $_REQUEST['card-expiry-month'];
        $curlPost['card_cvv'] = trim($_REQUEST['card-cvc']);
        $curlPost['source_ip'] = $this->getIP();
        $curlPost['source_url'] = $this->curPageURL();
        $curlPost['asyn_notify_url'] = $asyn_url ;
        $curlPost['syn_notify_url'] = $this->curPageURL();
        $curlPost['version'] = $gateway_version;
        $curlPost['signature'] = hash('sha256', $curlPost['merchant_id'] . $curlPost['app_id']  . $curlPost['order_no'] . $curlPost['order_amount'] . $curlPost['order_currency'] . $api_secret);

        //bill
        $curlPost['bill_firstname'] = Tools::safeOutput($customer->firstname);
        $curlPost['bill_lastname'] = Tools::safeOutput($customer->lastname);
        $curlPost['bill_email'] =  Tools::safeOutput($customer->email);
        $curlPost['bill_phone'] = Tools::safeOutput($address->phone_mobile ? $address->phone_mobile : $address->phone);
        $curlPost['bill_country'] = Tools::safeOutput($country->iso_code);
        $curlPost['bill_state'] = Tools::safeOutput($state->iso_code ? $state->iso_code : $address->state);
        $curlPost['bill_city'] = Tools::safeOutput($address->city);
        $curlPost['bill_street'] = Tools::safeOutput($address->address1 . ' ' . $address->address2);
        $curlPost['bill_zip'] = Tools::safeOutput($address->postcode);

        //shipping
        $curlPost['ship_firstname'] = Tools::safeOutput($customer->firstname);
        $curlPost['ship_lastname'] = Tools::safeOutput($customer->lastname);
        $curlPost['ship_email'] = Tools::safeOutput($customer->email);
        $curlPost['ship_phone'] = Tools::safeOutput($address->phone_mobile ? $address->phone_mobile : $address->phone);
        $curlPost['ship_country'] = Tools::safeOutput($country->iso_code);
        $curlPost['ship_state'] = Tools::safeOutput($state->iso_code ? $state->iso_code : $address->state);
        $curlPost['ship_city'] = Tools::safeOutput($address->city);
        $curlPost['ship_street'] = Tools::safeOutput($address->address1 . ' ' . $address->address2);
        $curlPost['ship_zip'] = Tools::safeOutput($address->postcode);

        $curlPost['custom_data'] = $data['order_no'];
        $curlPost['lang'] = 'en-us'; //zh-cn en-us
        //dump($curlPost);exit;

        $response = $this->curlSend($gateway_url,$curlPost,1);
        $result = json_decode($response,true);
        //dump($result);exit;

        $info = array(
            'OrderID' =>   $curlPost['custom_data'],
            'Amount'   =>   $curlPost['amount'],
            'Order time'     =>   date("Y-m-d H:i",time())
        );
        //处理完毕跳转模板
        //Sale transaction accept
        if($result['errcode'] == 0){
            //Pending
            //3D跳转
            if($result['data']['pay_url'] != '') {
                $redirect_url = urldecode($result['data']['pay_url']);
                header("Location: $redirect_url");
                exit;
            }

            if($result['data']['order_status'] == 1){
                $info['Payment result'] = $result['data']['info'];
                $this->context->smarty->assign([
                    'params' => $info,
                ]);
                $this->setTemplate('module:ipasspay_direct/views/templates/front/payment_pending.tpl');
            }
            //Approved
            if($result['data']['order_status'] == 2){
                $id_cart = $data['order_no'];
                $result = Db::getInstance()->getRow('SELECT id_order FROM ' . _DB_PREFIX_ . 'orders WHERE id_cart = ' . (int) $id_cart);
                $id_order = $result['id_order'];
                $order = new Order($id_order);
                $order->setCurrentState(2);

                $info['Payment result'] = 'Payment Success';
                $this->context->smarty->assign([
                   'params' => $info,
               ]);
               //dump($order);exit;
               $this->setTemplate('module:ipasspay_direct/views/templates/front/payment_success.tpl');
            }
            //Authorized
            if($result['data']['order_status'] == 4){
                $info['Payment result'] = 'Authorize Success';
                $this->context->smarty->assign([
                    'params' => $info,
                ]);
                $this->setTemplate('module:ipasspay_direct/views/templates/front/payment_authorize.tpl');
            }
            //Declined
            if($result['data']['order_status'] == 3){
                $info['Payment result'] = 'Payment Decline';
                $this->context->smarty->assign([
                    'params' => $info,
                ]);
                $this->setTemplate('module:ipasspay_direct/views/templates/front/payment_error.tpl');

            }

        }
        //Payment declined
        elseif($result['status'] != 0){
            $info['Payment result'] = $result['errmsg'];
            $this->context->smarty->assign([
                'params' => $info,
            ]);
            $this->setTemplate('module:ipasspay_direct/views/templates/front/payment_error.tpl');

        }
        //No response
        else{
            $info['result'] = 'No response';
            $this->context->smarty->assign([
                'params' => $info,
            ]);
            $this->setTemplate('module:ipasspay_direct/views/templates/front/payment_error.tpl');

        }

    }

    /**
     * 提交支付数据到网关
     */
    private function curlSend($process_gateway, $data_arr, $type = 1) {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $process_gateway);
        curl_setopt($ch, CURLOPT_POST, $type);
        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data_arr));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        $response = curl_exec($ch);
        curl_close($ch);
        return $response;
    }

    /**
     * 获取客户端IP
     */
    private function getIP() {
        if (@$_SERVER["HTTP_X_FORWARDED_FOR"]) {
            $ip = $_SERVER["HTTP_X_FORWARDED_FOR"];
        } else if (@$_SERVER["HTTP_CLIENT_IP"]) {
            $ip = $_SERVER["HTTP_CLIENT_IP"];
        } else if (@$_SERVER["REMOTE_ADDR"]) {
            $ip = $_SERVER["REMOTE_ADDR"];
        } else if (@getenv("HTTP_X_FORWARDED_FOR")) {
            $ip = getenv("HTTP_X_FORWARDED_FOR");
        } else if (@getenv("HTTP_CLIENT_IP")) {
            $ip = getenv("HTTP_CLIENT_IP");
        } else if (@getenv("REMOTE_ADDR")) {
            $ip = getenv("REMOTE_ADDR");
        } else {
            $ip = "127.0.0.1";
        }

        return $ip;
    }

    private function validate($number, $expiry_m, $expiry_y) {
        $this->cc_number = preg_replace('/[^0-9]/', '', $number);
        // NOTE: We check Solo before Maestro, and Maestro/Switch *before* we check Visa/Mastercard, so we don't have to rule-out numerous types from V/MC matching rules.
        if (preg_match('/^(6334[5-9][0-9]|6767[0-9]{2})[0-9]{10}([0-9]{2,3}?)?$/', $this->cc_number)) {
            $this->cc_type = "Solo"; // is also a Maestro product
        } else if (preg_match('/^(49369[8-9]|490303|6333[0-4][0-9]|6759[0-9]{2}|5[0678][0-9]{4}|6[0-9][02-9][02-9][0-9]{2})[0-9]{6,13}?$/', $this->cc_number)) {
            $this->cc_type = "Maestro";
        } else if (preg_match('/^(49030[2-9]|49033[5-9]|4905[0-9]{2}|49110[1-2]|49117[4-9]|49918[0-2]|4936[0-9]{2}|564182|6333[0-4][0-9])[0-9]{10}([0-9]{2,3}?)?$/', $this->cc_number)) {
            $this->cc_type = "Maestro"; // SWITCH is now Maestro
        } elseif (preg_match('/^4[0-9]{12}([0-9]{3})?$/', $this->cc_number)) {
            $this->cc_type = 'Visa';
        } elseif (preg_match('/^5[1-5][0-9]{14}$/', $this->cc_number)) {
            $this->cc_type = 'MasterCard';
        } elseif (preg_match('/^3[47][0-9]{13}$/', $this->cc_number)) {
            $this->cc_type = 'American Express';
        } elseif (preg_match('/^3(0[0-5]|[68][0-9])[0-9]{11}$/', $this->cc_number)) {
            $this->cc_type = 'Diners Club';
        } elseif (preg_match('/^(6011[0-9]{12}|622[1-9][0-9]{12}|64[4-9][0-9]{13}|65[0-9]{14})$/', $this->cc_number)) {
            $this->cc_type = 'Discover';
        } elseif (preg_match('/^(35(28|29|[3-8][0-9])[0-9]{12}|2131[0-9]{11}|1800[0-9]{11})$/', $this->cc_number)) {
            $this->cc_type = "JCB";
        } elseif (preg_match('/^5610[0-9]{12}$/', $this->cc_number)) {
            $this->cc_type = 'Australian BankCard'; // NOTE: is now obsolete
        } else {
            return -1;
        }

        if (is_numeric($expiry_m) && ($expiry_m > 0) && ($expiry_m < 13)) {
            $this->cc_expiry_month = $expiry_m;
        } else {
            return -2;
        }

        $current_year = date('Y');
        if (strlen($expiry_y) == 2) {
            $expiry_y = intval(substr($current_year, 0, 2) . $expiry_y);
        }

        if (is_numeric($expiry_y) && ($expiry_y >= $current_year) && ($expiry_y <= ($current_year + 10))) {
            $this->cc_expiry_year = $expiry_y;
        } else {
            return -3;
        }

        if ($expiry_y == $current_year) {
            if ($expiry_m < date('n')) {
                return -4;
            }
        }

        // check the issue month & year but only for Switch/Solo cards
        return $this->is_valid();
    }

    /*
    private function validate($number, $expiry_m, $expiry_y, $start_m, $start_y) {
        $this->cc_number = preg_replace('/[^0-9]/', '', $number);
        // NOTE: We check Solo before Maestro, and Maestro/Switch *before* we check Visa/Mastercard, so we don't have to rule-out numerous types from V/MC matching rules.
        if (preg_match('/^(6334[5-9][0-9]|6767[0-9]{2})[0-9]{10}([0-9]{2,3}?)?$/', $this->cc_number)) {
            $this->cc_type = "Solo"; // is also a Maestro product
        } else if (preg_match('/^(49369[8-9]|490303|6333[0-4][0-9]|6759[0-9]{2}|5[0678][0-9]{4}|6[0-9][02-9][02-9][0-9]{2})[0-9]{6,13}?$/', $this->cc_number)) {
            $this->cc_type = "Maestro";
        } else if (preg_match('/^(49030[2-9]|49033[5-9]|4905[0-9]{2}|49110[1-2]|49117[4-9]|49918[0-2]|4936[0-9]{2}|564182|6333[0-4][0-9])[0-9]{10}([0-9]{2,3}?)?$/', $this->cc_number)) {
            $this->cc_type = "Maestro"; // SWITCH is now Maestro
        } elseif (preg_match('/^4[0-9]{12}([0-9]{3})?$/', $this->cc_number)) {
            $this->cc_type = 'Visa';
        } elseif (preg_match('/^5[1-5][0-9]{14}$/', $this->cc_number)) {
            $this->cc_type = 'MasterCard';
        } elseif (preg_match('/^3[47][0-9]{13}$/', $this->cc_number)) {
            $this->cc_type = 'American Express';
        } elseif (preg_match('/^3(0[0-5]|[68][0-9])[0-9]{11}$/', $this->cc_number)) {
            $this->cc_type = 'Diners Club';
        } elseif (preg_match('/^(6011[0-9]{12}|622[1-9][0-9]{12}|64[4-9][0-9]{13}|65[0-9]{14})$/', $this->cc_number)) {
            $this->cc_type = 'Discover';
        } elseif (preg_match('/^(35(28|29|[3-8][0-9])[0-9]{12}|2131[0-9]{11}|1800[0-9]{11})$/', $this->cc_number)) {
            $this->cc_type = "JCB";
        } elseif (preg_match('/^5610[0-9]{12}$/', $this->cc_number)) {
            $this->cc_type = 'Australian BankCard'; // NOTE: is now obsolete
        } else {
            return -1;
        }

        if (is_numeric($expiry_m) && ($expiry_m > 0) && ($expiry_m < 13)) {
            $this->cc_expiry_month = $expiry_m;
        } else {
            return -2;
        }

        $current_year = date('Y');
        if (strlen($expiry_y) == 2) {
            $expiry_y = intval(substr($current_year, 0, 2) . $expiry_y);
        }

        if (is_numeric($expiry_y) && ($expiry_y >= $current_year) && ($expiry_y <= ($current_year + 10))) {
            $this->cc_expiry_year = $expiry_y;
        } else {
            return -3;
        }

        if ($expiry_y == $current_year) {
            if ($expiry_m < date('n')) {
                return -4;
            }
        }

        // check the issue month & year but only for Switch/Solo cards

        if (($start_m || $start_y) && in_array($this->cc_type, array('Switch', 'Solo'))) {
            if (!(is_numeric($start_m) && ($start_m > 0) && ($start_m < 13))) {
                return -2;
            }

            if (strlen($start_y) == 2) {
                if ($start_y > 80) {
                    $start_y = intval('19' . $start_y);
                } else {
                    $start_y = intval('20' . $start_y);
                }
            }

            if (!is_numeric($start_y) || ($start_y > $current_year)) {
                return -3;
            }
            if (!($start_y >= ($current_year - 10))) {
                return -3;
            }
        }
        return $this->is_valid();
    }
    */

    /**
     * 验证
     */
    private function is_valid() {
        $cardNumber = strrev($this->cc_number);
        $numSum = 0;

        for ($i = 0; $i < strlen($cardNumber); $i++) {
            $currentNum = substr($cardNumber, $i, 1);

            // Double every second digit
            if ($i % 2 == 1) {
                $currentNum *= 2;
            }

            // Add digits of 2-digit numbers together
            if ($currentNum > 9) {
                $firstNum = $currentNum % 10;
                $secondNum = ($currentNum - $firstNum) / 10;
                $currentNum = $firstNum + $secondNum;
            }

            $numSum += $currentNum;
        }

        // If the total has no remainder it's OK
        return ($numSum % 10 == 0);
    }

    /**
     * 异步通知
     **/
    public function asyNofity() {

        $merchant_id = Configuration::get('IPASSPAY_DIRECT_MERCHANT_ID');
        $app_id = Configuration::get('IPASSPAY_APP_ID');
        $api_secret = Configuration::get('IPASSPAY_API_SECRET');

        $order_id = $_REQUEST['custom_data'];
        $order_no = $_REQUEST['order_no'];
        $gateway_order_no = $_REQUEST['gateway_order_no'];
        $order_currency = $_REQUEST['order_currency'];
        $order_amount = $_REQUEST['order_amount'];
        $order_status = $_REQUEST['order_status'];
        $order_signature = $_REQUEST['signature'];

        $signature = hash('sha256', $merchant_id.$app_id.$order_no.
            $gateway_order_no.$order_currency.$order_amount.
            $order_status.$api_secret);

        if ($signature == $order_signature) {
            $id_cart = $order_id;
            $result = Db::getInstance()->getRow('SELECT id_order FROM ' . _DB_PREFIX_ . 'orders WHERE id_cart = ' . (int) $id_cart);
            $id_order = $result['id_order'];
            $order = new Order($id_order);
            //dump($order);exit;
            //订单存在且在待付款状态才处理
            if ($order && $order->current_state == 3){
                //更新订单状态
                switch ($order_status) {
                    case '2':
                        $order->setCurrentState(2);
                        break;
                    default:
                        break;
                }

            }
            $res = array(
                'errcode' => '0',
                'errmsg' => 'success'
            );
        } else {
            $res = array(
                'errcode' => '1',
                'errmsg' => 'failure'
            );
        }

        echo json_encode($res);
        exit;

    }

    protected function curPageURL()
    {
        $pageURL = 'http';

        if ($_SERVER["HTTPS"] == "on")
        {
            $pageURL .= "s";
        }
        $pageURL .= "://";

        if ($_SERVER["SERVER_PORT"] != "80")
        {
            $pageURL .= $_SERVER["SERVER_NAME"] . ":" . $_SERVER["SERVER_PORT"];
        }
        else
        {
            $pageURL .= $_SERVER["SERVER_NAME"];
        }
        return $pageURL;
    }

}
